# Copyright IBM Corporation 2020,2022
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# Non-actor methods
from kar.api import invoke
from kar.api import tell
from kar.api import call
from kar.api import shutdown
from kar.api import async_call

# Base and testing methods
from kar.api import base_call
from kar.api import test_server_health
from kar.api import test_actor_head

# Actor methods
from kar.api import actor_runtime
from kar.api import actor_proxy
from kar.api import actor_call
from kar.api import actor_remove
from kar.api import actor_root_call
from kar.api import actor_async_call
from kar.api import actor_encode_tail_call
from kar.api import actor_encode_tail_call_releasing_lock
from kar.api import actor_schedule_reminder
from kar.api import actor_get_reminder
from kar.api import actor_cancel_reminder

# Actor state methods:
from kar.api import actor_state_get_all
from kar.api import actor_state_get
from kar.api import actor_state_set
from kar.api import actor_state_contains
from kar.api import actor_state_remove
from kar.api import actor_state_remove_all
from kar.api import actor_state_remove_some
from kar.api import actor_state_set_multiple
from kar.api import actor_state_update

from kar.api import actor_state_submap_get
from kar.api import actor_state_submap_set
from kar.api import actor_state_submap_get_all
from kar.api import actor_state_submap_contains
from kar.api import actor_state_submap_remove
from kar.api import actor_state_submap_remove_all
from kar.api import actor_state_submap_remove_some
from kar.api import actor_state_submap_set_multiple
from kar.api import actor_state_submap_keys
from kar.api import actor_state_submap_size

# Eventing
from kar.api import events_create_subscription
from kar.api import events_publish
from kar.api import events_create_topic
from kar.api import events_delete_topic
from kar.api import events_cancel_subscription
from kar.api import events_get_subscription

# Base actor type
from kar.api import KarActor

__all__ = [
    'invoke', 'tell', 'call', 'actor_proxy', 'actor_call', 'actor_runtime',
    'KarActor', 'actor_remove', 'shutdown', 'test_actor_head', 'base_call',
    'test_server_health', 'actor_state_get_all', 'actor_state_get',
    'actor_state_set', 'actor_state_contains', 'actor_state_remove',
    'actor_state_remove_all', 'actor_state_remove_some',
    'actor_state_set_multiple', 'actor_state_update', 'actor_state_submap_set',
    'actor_state_submap_get', 'actor_state_submap_get_all',
    'actor_state_submap_contains', 'actor_state_submap_remove',
    'actor_state_submap_remove_all', 'actor_state_submap_remove_some',
    'actor_state_submap_set_multiple', 'actor_state_submap_keys',
    'actor_state_submap_size', 'events_create_subscription', 'events_publish',
    'events_create_topic', 'events_delete_topic', 'events_cancel_subscription',
    'events_get_subscription', 'async_call', 'actor_root_call',
    'actor_async_call', 'actor_encode_tail_call',
    'actor_encode_tail_call_releasing_lock', 'actor_schedule_reminder',
    'actor_get_reminder', 'actor_cancel_reminder'
]
